%define name	x86-compat-j2re
%define version	1.4.2
%define release	%mkrel 5

# Force use of /usr/lib on x86_64 builds
%define _libdir	%{_prefix}/lib

# Don't implicitly require libodbc{,inst}.so libraries without SONAME
%define __find_requires %{_builddir}/%{name}-%{version}/find_requires.sh
%define __find_provides %{_builddir}/%{name}-%{version}/find_provides.sh

Name:		%{name}
Summary:	Java Runtime Environment from Sun Microsystelms, Inc.
Version:	%{version}
Release:	%{release}
Source:		j2re-1.4.2-03-linux-i586.bin
URL:		http://java.sun.com/j2se/1.4/
Group:		Development/Java
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
License:	Commercial
Provides:	jre32 = %{version}
BuildRequires:	textutils expect
ExclusiveArch:	%{ix86} x86_64

%description
The Java 2 Runtime Enviornment consists of the Java virtual machine,
the Java platform core classes, and supporting files. It is the runtime
part of the Java 2 SDK, but without the development tools such as
compilers and debuggers.

The JRE is freely redistributable, per the terms of the included
license, when bundled with Java applets and applications.

%prep
%setup -c -T -q
cat << EOF > extract_jdk
#!/usr/bin/expect -f
set timeout -1
set package [lrange \$argv 0 0]
spawn \$package
expect {
"More"	{ send \n ; exp_continue}
"no]"	{ send yes\n ; exp_continue}
eof 	{ exit}
}
EOF
chmod +x extract_jdk
chmod +x %{SOURCE0}

cat > find_requires.sh << EOF
%{_prefix}/lib/rpm/find-requires %{buildroot} %{_target_cpu} | egrep -v "libodbc(|inst)\.so$"
exit 0
EOF
chmod +x find_requires.sh

cat > find_provides.sh << EOF
%{_prefix}/lib/rpm/find-provides | grep -v libodbc
exit 0
EOF
chmod +x find_provides.sh

%build
Extract=$PWD/extract_jdk
LC_ALL=C $Extract %{SOURCE0}

%install
rm -rf $RPM_BUILD_ROOT

# install all JRE
mkdir -p $RPM_BUILD_ROOT%{_libdir}/jre-%{version}
cp -r j2re%{version}/* $RPM_BUILD_ROOT%{_libdir}/jre-%{version}

# create fake libs linked on real ODBC DSOs
pushd $RPM_BUILD_ROOT%{_libdir}/jre-%{version}/lib/i386
for f in odbc odbcinst; do
echo '.text' | gcc -shared -o lib$f.so -xassembler -l$f
done
popd

# create links for Mozilla plugins
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mozilla/plugins
ln -sf %{_libdir}/jre-%{version}/plugin/i386/mozilla/libjavaplugin_oji.so $RPM_BUILD_ROOT%{_libdir}/mozilla/plugins/

# export JAVA32_HOME directory
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/
cat << EOF > $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/x86-compat-jre-%{version}.sh
if [ -z "\$JAVA32_HOME" ]; then 
  export JAVA32_HOME=%{_libdir}/jre-%{version}
fi
EOF
cat << EOF > $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/x86-compat-jre-%{version}.csh
if ( ! \$?JAVA32_HOME ) then
  setenv JAVA32_HOME %{_libdir}/jre-%{version}
endif
EOF
chmod a+x $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/*

# remove duplicates
rm -f  $RPM_BUILD_ROOT%{_libdir}/jdk-%{version}/{COPYRIGHT,INSTALL,LICENSE,README*,THIRDPARTYLICENSEREADME.txt}
rm -rf $RPM_BUILD_ROOT%{_libdir}/jdk-%{version}/jre/.systemPrefs/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc j2re%{version}/CHANGES
%doc j2re%{version}/COPYRIGHT
%doc j2re%{version}/LICENSE
%doc j2re%{version}/README
%doc j2re%{version}/THIRDPARTYLICENSEREADME.txt
%{_sysconfdir}/profile.d/x86-compat-jre-%{version}.*sh
%dir %{_libdir}/jre-%{version}
%{_libdir}/jre-%{version}/*
%{_libdir}/mozilla/plugins/libjavaplugin_oji.so

%changelog
* Thu Sep 14 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.4.2-5mdk
- 1.4.2-03

* Mon Sep 19 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.4.2-4mdk
- define JAVA32_HOME

* Tue Sep 13 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.4.2-3mdk
- 1.4.2-02

* Mon Apr 11 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.4.2-2mdk
- 1.4.2-01

* Wed Nov  3 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.4.2-1mdk
- Blackdown.org 1.4.2-fcs
